package com.adamatomic.Mode
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import org.flixel.*;

	public class Bullet extends FlxSprite
	{
		[Embed(source="../../../data/bullet.png")] private var ImgBullet:Class;
		[Embed(source="../../../data/jump.mp3")] private var SndHit:Class;
		[Embed(source="../../../data/shoot.mp3")] private var SndShoot:Class;
		
		private var _n:int;
		private var _dir:Boolean;
		private var _vel:Number;
		private var _pressed:Boolean;
		private var _key:String;
		
		public function Bullet(n_:int, vel_:Number )
		{
			super();
			_n = n_;
			_dir = true;
			_vel = vel_*PlayState.basespeed;
			y = FlxG.height / 2 + 16 / 2;
			_pressed = true;
			switch(_n)
			{
				case 1:
				_key = "ONE";
				break;
				case 2:
				_key = "TWO";
				break;
				case 3:
				_key = "THREE";
				break;
				case 4:
				_key = "FOUR";
				break;
				case 5:
				_key = "FIVE";
				break;
				case 6:
				_key = "SIX";
				break;
				case 7:
				_key = "SEVEN";
				break;
				case 8:
				_key = "EIGHT";
				break;
				case 9:
				_key = "NINE";
				break;
				case 0:
				_key = "ZERO";
				break;
				default:
				trace("ERR13");
				break;
			}
			
			switch (_n)
			{
				case 1:
				case 2:
				case 3:
				case 4:
				 x = 10 + (_n-1)*20;
				 break;
				case 5:
				case 6:
				x = 0;
				break;
				case 7:
				case 8:
				case 9:
				 x = FlxG.width - 16 - 10 - (10-_n) * 20;
				 break;
				case 0:
				 x = FlxG.width - 16 - 10 - (10-10) * 20;
				break;
				default:
				trace("ERRROR1" + _n.toString() );
			}
			this.velocity.x = 0;
			this.velocity.y = _vel;
			this.acceleration.x = 0;
			this.acceleration.y = 0;
			this.loadGraphic(ImgBullet,false,false,8,8);
			this.offset.x = -4;
			this.offset.y = -4;
			addAnimation("default", [0, 1], 0, false);
			play("default",true);
			this.color = 0xf0ff00;
			this.update();
		}
		
		override public function update():void
		{
			if (dead && finished) exists = false;
			else 
			{
				var wason:Boolean = false;
				if (Math.abs(this.y  - (FlxG.height / 2 - 16/2) ) < 16 )
				{
					if (this.color != 0xff0000 && this.color != 0xfffffe)
					{
						this.color = 0xff0000;						
						this.frame = 1;
					}
					wason = true;
					if (!_pressed && FlxG.keys.justPressed(_key))
					{
						_pressed = true;
						PlayState._em2.at(this);
						PlayState._em2.start(true, 2, 10);
						this.color = 0xfffffe;
						this.frame = 0;
					}
				}
				else
				{
					this.color = 0xffffff;
					this.frame = 0;
					_pressed = false;
					
					if (FlxG.keys.justPressed(_key))
					{
						if (PlayState._timein > 0.3 && !this.flickering())
						{
							//oops decrease health
							this.flicker(0.5);
							if (PlayState.health > 0)
							{
								PlayState.health--;
								PlayState._healthLbl.flicker(1);
							}
							PlayState._em.at(this);
							PlayState._em.start(true, 2, 10);
						}
					}
				}
				
				if (this._dir)
				{
					if (this.y + 16  >= FlxG.height)
					{
						this._dir = !this._dir;
						this.velocity.y = -this.velocity.y;
					}
				}
				else
				{
					if (this.y<=0)
					{
						this._dir = !this._dir;
						this.velocity.y = -this.velocity.y;
					}					
				}
				super.update();
				
				if (wason)
				{
					if (! (Math.abs(this.y  - (FlxG.height / 2 - 16/2) ) < 16 ))
					{
						if (!_pressed  && !this.flickering())
						{
							//oops decrease health
							this.flicker(0.5);
							if (PlayState.health > 0)
							{
								PlayState.health--;
								PlayState._healthLbl.flicker(1);

							}
							PlayState._em.at(this);
							PlayState._em.start(true, 2, 10);
						}
						else
						{
						}
						_pressed = false;
					}
				}
			}
		}
		
		override public function render():void
		{
			super.render();
		}

		override public function hitLeft(Contact:FlxObject,Velocity:Number):void { kill(); }
		override public function hitBottom(Contact:FlxObject,Velocity:Number):void { kill(); }
		override public function hitTop(Contact:FlxObject,Velocity:Number):void { kill(); }
		override public function kill():void
		{
			if(dead) return;
			velocity.x = 0;
			velocity.y = 0;
			if(onScreen()) FlxG.play(SndHit);
			dead = true;
			solid = false;
			play("poof");
		}
		
		
	}
}